#from math import *
import matplotlib.pyplot as plt
import os
import csv
import numpy
import Gnuplot, Gnuplot.funcutils
# Path to folders
main_path='../'

# Run directories
run_dir=['dt_0.0001','dt_0.0004','dt_0.0025','dt_0.01']

# Plot directory
plot_dir1='./plots/'+''.join(run_dir)+'/matplotlib/'

# File names
read_file='Error'

# Names on every label
labelX=r'$\Delta x$'
labelY=r'$Error$'

dashes = ['-','--','-.',':','+','*',',','.','1','2','3',
          '4','<','>','D','H','^','_',
          'd','h','o','p','s','v','x','|']

# Initialize figures
plt.figure(1)                # the first figure
plt.subplot(111)             # the first subplot in the first figure

dx=[]
E=[]
dt=[]
for files in run_dir:
    f1 = open(main_path+files+'/'+read_file,'r')
    f2 = open(main_path+files+'/'+read_file,'r')
    f3 = open(main_path+files+'/'+read_file,'r')
    dx.append(float((list(f1)[-1]).split()[1]))
    E.append(float((list(f2)[-1]).split()[2]))
    dt.append(float((list(f3)[2]).split()[0]))

logdx=numpy.log10(dx)
logdt=numpy.log10(dt)
logE=numpy.log10(E)
coeff=numpy.polyfit(logdx,logE,1)
p=numpy.poly1d(coeff)
logEfit=p(logdx)
logEslope2=logdx*2+coeff[1]
plt.xlabel(labelX)
plt.ylabel(labelY)
plt.title('Error vs Grid Resolution') 
plt.yscale('log')
plt.xscale('log')
plt.plot(dx,E,'-o',label='data')
plt.plot(dx,10**logEfit,'--',label=r'y='+str("%.3f" %coeff[0])+r'log(dx)'+str("%.3f" %coeff[1]))
plt.plot(dx,10**logEslope2,'-+',label=r'y=2log(dx)'+str("%.3f" %coeff[1]))
plt.legend(loc=4)
plt.savefig('logE_logdx.eps')
#plt.savefig(''.join(run_dir)+'_dx.eps')
plt.clf()
del p, coeff, logEfit
coeff=numpy.polyfit(logdt,logE,1)
p=numpy.poly1d(coeff)
logEfit=p(logdt)
logEslope1=logdt+coeff[1]
plt.xlabel(r'$\Delta t$')
plt.ylabel(labelY)
plt.title('Error vs Time Resolution')
plt.yscale('log')
plt.xscale('log')
plt.plot(dt,E,'-o',label='data')
plt.plot(dt,10**logEfit,'--',label=r'y='+str("%.3f" %coeff[0])+r'log(dt)'+str("%.3f" %coeff[1]))
plt.plot(dt,10**logEslope1,'-+',label=r'y=log(dx)'+str("%.3f" %coeff[1]))
plt.legend(loc=4)
plt.savefig('logE_logdt.eps')
#plt.savefig(''.join(run_dir)+'_dt.eps')
